const int ledPin = 13;              // choose the pin for the LED
const int buttonPin = 2;            // choose the input pin (for a pushbutton)

int buttonState = 0;                // variable for reading the pin status
int blink_delay = 0;                // the delay for blinking
int lastButtonState = LOW;          // for keeping track of last registered state
int lastToggle_ms = 0;              // for keeping track of time


void setup() {
  pinMode(ledPin, OUTPUT);      // declare LED as output
  pinMode(buttonPin, INPUT);    // declare pushbutton as input
}

void loop(){
  buttonState = digitalRead(buttonPin);  // read input value
  if (buttonState == HIGH) {             // check if the input is HIGH (button pushed)
    
    //To debounce, wait 50 ms then check the state of the pin again
    delay(50);
    if (digitalRead(buttonPin) == HIGH && lastButtonState == LOW)
    { 
      //A push has been detected, do whatever:   
      blink_delay += 250;
      if (blink_delay > 550)
        blink_delay = 50;
      
      //Remember the state of the button to make sure it is registered only once
      lastButtonState = HIGH;
    }
  }  
  else
    lastButtonState = LOW;
  
  //Timer for controlling the blink frequency
  if (millis() > lastToggle_ms + blink_delay) {
    digitalWrite(ledPin, !digitalRead(ledPin));  // toggle LED
    lastToggle_ms = millis();
  }
}
